#![feature(core_intrinsics)]
use std::{path::PathBuf, process::ExitCode, time::Duration};

use clap::Parser;

mod display;
mod plugman;

#[derive(Debug, Parser)]
struct CliArgs {
    #[arg(long, short, default_value="./plugins")]
    plugin_dir: camino::Utf8PathBuf,
}

fn main() -> ExitCode {
    // let ca = CliArgs::parse();
    let Ok(mut disp) = display::Display::new() else {
        return ExitCode::from(1);
    }; 
    

    let mut pm = plugman::PlugMan::new(1024); // idk tbh
    if let Err(e) = pm.load(PathBuf::from("./plugins")
        //ca.plugin_dir.as_std_path().to_path_buf()
        ){
        eprintln!("ERROR: Failed to load plugins: {e:?}"); 
    }

    pm.init_plugins();
    
    let mut buf = String::new();

    loop {
        buf.clear();
        let values = pm.poll_plugins();
        for (_plug_name, val) in values {
            buf.push_str(val.as_str());
        }
        let _ = disp.write_display_name(&buf);
        std::thread::sleep(Duration::from_millis(250));
    }
}
